<template>
    <div class="pa-4">
        <v-row>
            <v-col>
                <div class="subtitle-1 text--secondary">
                    {{ $t('user_', [$t('profile')]) }}
                </div>
            </v-col>
        </v-row>

        <v-divider></v-divider>

        <v-row>
            <v-col cols="12" md="6">
                <div class="field-label">{{ $t('first_name') }}</div>
                <ValidationProvider v-slot="{ errors }" name="first_name" rules="required">
                    <v-text-field
                        v-model="user.profile.first_name"
                        :loading="loading"
                        :placeholder="$t('user_', [$t('first_name')])"
                        :error-messages="errors"
                        outlined
                    >
                    </v-text-field>
                </ValidationProvider>
            </v-col>

            <v-col cols="12" md="6">
                <div class="field-label">{{ $t('last_name') }}</div>
                <ValidationProvider v-slot="{ errors }" name="last_name" rules="required">
                    <v-text-field
                        v-model="user.profile.last_name"
                        :loading="loading"
                        :placeholder="$t('user_', [$t('last_name')])"
                        :error-messages="errors"
                        outlined
                    ></v-text-field>
                </ValidationProvider>
            </v-col>

            <v-col cols="12" md="6">
                <div class="field-label">{{ $t('email') }}</div>
                <v-text-field
                    v-model="user.email"
                    :loading="loading"
                    :placeholder="$t('user_', [$t('email')])"
                    disabled
                    outlined
                ></v-text-field>
            </v-col>

            <v-col cols="12" md="6">
                <div class="field-label">{{ $t('mobile') }}</div>
                <ValidationProvider v-slot="{ errors }" name="mobile" rules="required|mobile">
                    <v-tel-input
                        v-model="user.profile.mobile"
                        :placeholder="$t('user_', [$t('mobile')])"
                        :errors="errors"
                    ></v-tel-input>
                </ValidationProvider>
            </v-col>
        </v-row>

        <v-row>
            <v-col class="text-center">
                <v-btn
                    @click="updateProfile"
                    :loading="updating"
                    class="text--white mx-2"
                    color="primary"
                    large
                >
                    <v-icon left>mdi-content-save</v-icon>
                    {{ $t('save') }}
                </v-btn>
            </v-col>
        </v-row>

        <v-row>
            <v-col>
                <div class="subtitle-1 text--secondary">
                    {{ $t('user_', [$t('payment_methods')]) }}
                </div>
            </v-col>
        </v-row>

        <v-divider></v-divider>

        <v-row>
            <v-col>
                <payment-methods
                    v-model="showDeleteDialog"
                    :items="methods"
                    :loading="fetchingMethods || deleting"
                    @remove="removePaymentMethod"
                ></payment-methods>
            </v-col>
        </v-row>
    </div>
</template>

<script>
    import { ValidationObserver, ValidationProvider } from 'vee-validate';
    import { mapMutations } from "vuex";
    import VTelInput from "../VTelInput";
    import PaymentMethods from "../payments/PaymentMethods";

    export default {
        name: 'UserInfo',
        props: ['id'],
        components: {
            PaymentMethods,
            VTelInput,
            ValidationObserver,
            ValidationProvider
        },
        data: () => ({
            loading: false,
            updating: false,
            fetchingMethods: false,
            deleting: false,
            showDeleteDialog: false,
            user: {
                email: undefined,
                profile: {
                    first_name: undefined,
                    last_name: undefined,
                    mobile: undefined
                }
            },
            methods: []
        }),
        created() {
            this.fetchUser();
            this.fetchPaymentMethods();
        },
        methods: {
            ...mapMutations('snackbar', [
                'success',
                'error'
            ]),

            fetchUser() {
                this.loading = true;

                axios.get(`api/accounts/${this.id}`)
                    .then(({ data }) => {
                        this.user = data;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.loading = false;
                    })
            },

            fetchPaymentMethods() {
                this.fetchingMethods = true;

                axios.get(`api/accounts/${this.id}/payments/methods`)
                    .then(({ data }) => {
                        this.methods = data;
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.fetchingMethods = false;
                    })
            },

            updateProfile() {
                this.updating = true;

                axios.put(`api/accounts/${this.id}`, this.user.profile)
                    .then(() => {
                        this.success(this.$t('profile_action.updated'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.updating = false;
                    })
            },

            removePaymentMethod(id) {
                this.deleting = true;

                axios.delete(`api/payments/methods/${this.id}/${id}`)
                    .then(() => {
                        const index = this.methods.findIndex(methods => methods.id === id);
                        this.methods.splice(index, 1);
                        this.success(this.$t('payment_methods_action.remove'));
                    })
                    .catch(({ response }) => {
                        this.error(response.data.message);
                    })
                    .finally(() => {
                        this.deleting = false;
                        this.showDeleteDialog = false;
                    })
            }
        }
    }
</script>

<style scoped>

</style>
